

#include "p18f46j50.h"
#include "colorlcd_lib24b.h"
#include "Sensor_config.h"
#include "hardwareProfile.h"

#define OV7670_REG_NUM  167
#define OV7725_REG_NUM  72


void startSCCB(void);
void stopSCCB(void);
void noAck(void);
unsigned char SCCBwriteByte(unsigned char m_data);
unsigned char wr_Sensor_Reg(unsigned char regID, unsigned char regDat);
unsigned char rd_Sensor_Reg(unsigned char regID, unsigned char *regDat);
//unsigned char rd_Sensor_Reg(unsigned char regID);
unsigned char SCCBreadByte(void);
unsigned char Sensor_init(void);

//rom char OV7670_reg[OV7670_REG_NUM][2];

void delay_us(unsigned short usec);


unsigned char wr_Sensor_Reg(unsigned char regID, unsigned char regDat)
{
	delay_us(100);
	startSCCB();   //
	if(0==SCCBwriteByte(0x42))	//
	{
		stopSCCB();		//
		return(0);		//
	}
  	if(0==SCCBwriteByte(regID))		//
	{
		stopSCCB();		//
		return(0);		//
	}
  	if(0==SCCBwriteByte(regDat))	//
	{
		stopSCCB();		//
		return(0);		//
	}
  	stopSCCB();			//
	
  	return(1);			//
}



unsigned char rd_Sensor_Reg(unsigned char regID, unsigned char *regDat)
{
	unsigned char data;	
	delay_us(500);
	startSCCB();
	if(SCCBwriteByte(0x42)== 0)    //
		{
		stopSCCB();		//
		return(0);		//
		}
  	if(SCCBwriteByte(regID)== 0)		
		{
		stopSCCB();		
		return(0);		
		}
	stopSCCB();			
	
	delay_us(500);
	
	startSCCB();
	if(SCCBwriteByte(0x43)== 0)	
	{
		stopSCCB();		
		return(0);		
	}
	SCCB_SID_DIR = 1;		// SDA = IN
  	*regDat=SCCBreadByte();	//
  	noAck();	//
  	stopSCCB();	//
  	return(1);	//
}





unsigned char Sensor_init(void)
{
	unsigned char temp;
	unsigned int i=0;
      
	temp=0x80;
	if(0==wr_Sensor_Reg(0x12, 0x80)) //Reset SCCB
		{
        return 0;	//
		}
    delay_us(10);
	if(0==rd_Sensor_Reg(0x0b, &temp))	//Product ID  0x73 
		{
		return 0;	//
		}
        
    if(temp==0x73)//OV7670
	 	{
		i = 0;
		while(OV7670_QQVGA_reg[i][0] != 0xff)
	   		{
			if(wr_Sensor_Reg(OV7670_QQVGA_reg[i][0],OV7670_QQVGA_reg[i][1]) == 0)
				{
				return 0;
				}
			delay_ms(1);
			i++;
			}
		}
	return 0x01; //ok
}



void startSCCB(void)
{
    SCCB_SID = 1;     
    delay_us(100);

    SCCB_SIC = 1;	  
    delay_us(100);
 
    SCCB_SID = 0;
    delay_us(100);

    SCCB_SIC = 0;	
    delay_us(100);
}


void stopSCCB(void)
{
    SCCB_SID = 0;
    delay_us(10);
 
    SCCB_SIC = 1;	
    delay_us(10);

    SCCB_SID = 1;	
    delay_us(500);
}


void noAck(void)
{
	SCCB_SID = 1;	
	delay_us(10);
	
	SCCB_SIC = 1;	
	delay_us(10);
	
	SCCB_SIC = 0;	
	delay_us(10);
	
	SCCB_SID = 0;	
	delay_us(10);
}



unsigned char SCCBwriteByte(unsigned char m_data)
{
	unsigned char j,tem;

	for(j=0;j<8;j++) //
		{
		if((m_data<<j) & 0x80)
			{
			SCCB_SID = 1;	
			}
		else
			{
			SCCB_SID = 0;	
			}
		delay_us(10);
		SCCB_SIC = 1;	
		delay_us(10);
		SCCB_SIC = 0;	
		delay_us(10);
		}
	SCCB_SID = 0;
	delay_us(10);
	SCCB_SIC = 1;	
	delay_us(10); 
	SCCB_SIC = 0;;	
	delay_us(10);	
	return (tem);  
}



unsigned char SCCBreadByte(void)
{
	unsigned char read,j;
	read=0x00;
	
	SCCB_SID_DIR = 1;		// SDA = IN
	delay_us(500);
	for(j=8;j>0;j--) //
		{		     
		delay_us(10);
		SCCB_SIC = 1;
		delay_us(10);
		read = read <<1;
		if(SCCB_SID_IN == 1) 
			{
			read = read | 0x01;
			}
		SCCB_SIC = 0;
		delay_us(10);
		}	
    SCCB_SID_DIR = 0;	// SDA = out
	return(read);
}
