/*----------------------------------------------------------------------------

     @@@@@@@@gWX^Zp@2012N3   JW[eXgvO
    @@@@@@@@@@PIC16F1938{FIFOȂJW[pieNmW[j
    @@                                                    by@c@dH
                                                           (DENKO TANAKA)
 
 @@@@@@@@@@@@@-JW[̏̓TvvOQlɂ܂-
 
 *----------------------------------------------------------------------------*/
#include <htc.h>

//RtBO[V[h
__CONFIG(FOSC_INTOSC & CLKOUTEN_ON & MCLRE_ON & BOREN_OFF & WDTE_OFF);
//fBC֐̂߂̃NbN`
#define _XTAL_FREQ 32000000

//                  PIC16F1938
//               +-------u-------+
//            -->|/MCLR       RB7|-->  LED3
//        G4  -->|RA0         RB6|-->  LED2
//        G5  -->|RA1         RB5|-->  LED1
//        B3  -->|RA2         RB4|-->  LED0
//        B4  -->|RA3         RB3|--> (nc)
//       (nc) <--|RA4         RB2|--> (nc)
//       (nc) <--|RA5         RB1|<--  VSYNC
//            ===|VSS         RB0|<--  HREF
//    (X-tal) -->|CLKIN/RA7   VDD|===
//    (32MHz) <--|CLKOUT/RA6  VSS|===
//       (nc) <--|RC0     RC7/RxD|<--USB_TxD(3V)
//  SCCB SCL  <--|RC1     RC6/TxD|-->USB_RxD(3V)
//  SCCB SDA  <->|RC2         RC5|--> (nc)
//       (nc) <--|RC3         RC4|--> (nc)
//               +---------------+

unsigned char COL[255];
unsigned char CNT;

//********************JW[f[^**********************************
const  char OV7670_reg[167][2]=
{ 
  	{0x3a, 0x04},
	{0x40, 0x10},
	{0x12, 0x14},
	{0x32, 0x88},
	{0x17, 0x39},//1 line
	{0x18, 0x39},
	{0x19, 0x02},
	{0x1a, 0x7b},
	{0x03, 0x0a},
	{0x0c, 0x0c},//*****10
	{0x3e, 0x00},
	{0x70, 0x00},
	{0x71, 0x01},
	{0x72, 0x11},
	{0x73, 0x09},
	{0xa2, 0x02},
	{0x11, 0x9F},
	{0x7a, 0x20},
	{0x7b, 0x1c},
	{0x7c, 0x28},//*****20
	{0x7d, 0x3c},
	{0x7e, 0x55},
	{0x7f, 0x68},
	{0x80, 0x76},
	{0x81, 0x80},
	{0x82, 0x88},
	{0x83, 0x8f},
	{0x84, 0x96},
	{0x85, 0xa3},
	{0x86, 0xaf},//*****30
	{0x87, 0xc4},
	{0x88, 0xd7},
	{0x89, 0xe8},
	{0x13, 0xe0},
	{0x00, 0x00},
	{0x10, 0x00},
	{0x0d, 0x00},
	{0x14, 0x10},
	{0xa5, 0x05},
	{0xab, 0x07},//*****40
	{0x24, 0x75},
	{0x25, 0x63},
	{0x26, 0xA5},
	{0x9f, 0x78},
	{0xa0, 0x68},
	{0xa1, 0x03},
	{0xa6, 0xdf},
	{0xa7, 0xdf},
	{0xa8, 0xf0},
	{0xa9, 0x90},//*****50
	{0xaa, 0x94},
	{0x13, 0xe5},
	{0x0e, 0x61},
	{0x0f, 0x4b},
	{0x16, 0x02},
	{0x1e, 0x27},
	{0x21, 0x02},
	{0x22, 0x91},
	{0x29, 0x07},
	{0x33, 0x0b},//*****60
	{0x35, 0x0b},
	{0x37, 0x1d},
	{0x38, 0x71},
	{0x39, 0x2a},
	{0x3c, 0x78},
	{0x4d, 0x40},
	{0x4e, 0x20},
	{0x69, 0x5d},
	{0x6b, 0x40},
	{0x74, 0x19},//*****70
	{0x8d, 0x4f},
	{0x8e, 0x00},
	{0x8f, 0x00},
	{0x90, 0x00},
	{0x91, 0x00},
	{0x92, 0x00},
	{0x96, 0x00},
	{0x9a, 0x80},
	{0xb0, 0x84},
	{0xb1, 0x0c},//*****80
	{0xb2, 0x0e},
	{0xb3, 0x82},
	{0xb8, 0x0a},
	{0x43, 0x14},
	{0x44, 0xf0},
	{0x45, 0x34},
	{0x46, 0x58},
	{0x47, 0x28},
	{0x48, 0x3a},
	{0x59, 0x88},//*****90
	{0x5a, 0x88},
	{0x5b, 0x44},
	{0x5c, 0x67},
	{0x5d, 0x49},
	{0x5e, 0x0e},
	{0x64, 0x04},
	{0x65, 0x20},
	{0x66, 0x05},
	{0x94, 0x04},
	{0x95, 0x08},//*****100
	{0x6c, 0x0a},
	{0x6d, 0x55},
	{0x6e, 0x11},
	{0x6f, 0x9f},
	{0x6a, 0x40},
	{0x13, 0xe7},
	{0x15, 0x00},
	{0x4f, 0x80},
	{0x50, 0x80},
	{0x51, 0x00},//*****110
	{0x52, 0x22},
	{0x53, 0x5e},
	{0x54, 0x80},
	{0x55, 0x00},
	{0x56, 0x60},
	{0x57, 0x90},	
	{0x58, 0x9e},	
	{0x41, 0x08},
	{0x3f, 0x05},
	{0x75, 0x05},//*****120
	{0x76, 0xe1},
	{0x4c, 0x0F},
	{0x77, 0x0a},
	{0x3d, 0xc2},
	{0x4b, 0x09},
	{0xc9, 0xc8},
	{0x41, 0x38},
	{0x34, 0x11},
	{0x3b, 0x02},
	{0xa4, 0x89},//*****130
	{0x96, 0x00},
	{0x97, 0x30},
	{0x98, 0x20},
	{0x99, 0x30},
	{0x9a, 0x84},
	{0x9b, 0x29},
	{0x9c, 0x03},
	{0x9d, 0x4c},
	{0x9e, 0x3f},
	{0x78, 0x04},//*****140
	{0x79, 0x01},
	{0xc8, 0xf0},
	{0x79, 0x0f},
	{0xc8, 0x00},
	{0x79, 0x10},
	{0xc8, 0x7e},
	{0x79, 0x0a},
	{0xc8, 0x80},
	{0x79, 0x0b},
	{0xc8, 0x01},//*****150
	{0x79, 0x0c},
	{0xc8, 0x0f},
	{0x79, 0x0d},
	{0xc8, 0x20},
	{0x79, 0x09},
	{0xc8, 0x80},
	{0x79, 0x02},
	{0xc8, 0xc0},
	{0x79, 0x03},
	{0xc8, 0x40},//*****160
	{0x79, 0x05},
	{0xc8, 0x30},
	{0x69, 0xaa},
	{0x09, 0x00},
	{0x3b, 0x42},
	{0x2d, 0x01},
};

//********************I/O|[g֐**********************************
void PIC_Init(void)
{
	//NbN̐ݒ
	OSCCON = 0xF0;	// 0b11110000 internal 8x4=32MHz
	//IvVWX^̐ݒ
	OPTION_REG = 0x7FFF;//0b01111111 #WPUEN=0 INTDG=1(rising)
	//荞݊֌W̐ݒ
	INTCON = 0x00;//0b00000000
	PIE1   = 0x00;//0b00000000
	PIE2   = 0x00;//0b00000000
	PIE3   = 0x00;//0b00000000
	PIR1   = 0x00;//0b00000000
	PIR2   = 0x00;//0b00000000
	PIR3   = 0x00;//0b00000000
	IOCBP  = 0x00;//0b00000000
	IOCBN  = 0x00;//0b00000000
	IOCBF  = 0x00;//0b00000000
	//|[g̑փsݒ
	APFCON = 0x00;//0b00000000
	//|[gA̐ݒ
	PORTA  = 0x00;//0b00000000
	TRISA  = 0x8F;//0b10001111
	ANSELA = 0x00;//0b00000000
	//|[gB̐ݒ
	PORTB  = 0x00;//0b00000000
	TRISB  = 0x03;//0b00000011
	WPUB   = 0xFF;//0b11111111
	ANSELB = 0x00;//0b00000000
	//|[gC̐ݒ
	PORTC  = 0x40;//0b01000000
	TRISC  = 0xC4;//0b11000100
}

//********************************VA|[g֐***********************************
void COM_Init(void)
{
	BAUDCON = 0x40;//0b010000000
	SPBRGH  = 0x00;//0b00000000
	SPBRG   = 0x22;//34(57600bps at 32MHz Hi)
	TXSTA   = 0x26;//0b00100110 BRGH = hi
	RCSTA   = 0x90;//0b10010000
}

void putc(unsigned char sdata)
{
	while(PIR1bits.TXIF == 0){ }//PIR1WX^TXIFrbgPɂȂ܂ő҂
	TXREG = sdata;
}

unsigned char getc(void)
{
	while(PIR1bits.RCIF == 0){ }//PIR1WX^RCIFrbgPɂȂ܂ő҂
	return(RCREG);
}

//********************************SCCB֐***********************************
void SCCB_RD(void)
{
	TRISC  |= 0x04;//0b00000100
}

void SCCB_WR(void)
{
	TRISC  &= 0xFB;//0b11111011
}

void SCCB_C_H(void)
{
	PORTC |= 0x02;//0b00000010
}

void SCCB_C_L(void)
{
	PORTC &= 0xFD;//0b11111101
}

void SCCB_D_H(void)
{
	PORTC |= 0x04;//0b00000100
}

void SCCB_D_L(void)
{
	PORTC &= 0xFB;//0b11111011
}

unsigned char SCCB_D_RD(void)
{
	if(PORTCbits.RC2 == 0) return 0x00;
	else return 0x01;
}

void startSCCB(void)
{
    SCCB_D_H();
    __delay_us(500);
    SCCB_C_H();
    __delay_us(500);
    SCCB_D_L();
    __delay_us(500);
    SCCB_C_L();
    __delay_us(500);
}

void stopSCCB(void)
{
    SCCB_D_L();
    __delay_us(500);
    SCCB_C_H();	
    __delay_us(500);
    SCCB_D_H();	
    __delay_us(500);
}

void noAck(void)
{
	SCCB_D_H();	
	__delay_us(500);
	SCCB_C_H();
	__delay_us(500);
	SCCB_C_L();	
	__delay_us(500);	
	SCCB_D_L();	
	__delay_us(500);
}

unsigned char SCCBwriteByte(unsigned char m_data)
{
	unsigned char j,tem;

	for(j = 0; j < 8; j++)
	{
		if((m_data<<j)&0x80)
		{
			SCCB_D_H();	
		}
		else
		{
			SCCB_D_L();	
		}
		__delay_us(500);
		SCCB_C_H();	
		__delay_us(500);
		SCCB_C_L();	
		__delay_us(500);
	}
	__delay_us(100);
	SCCB_RD();
	__delay_us(500);
	SCCB_C_H();	
	__delay_us(100);
	if(SCCB_D_RD() == 1){tem=0;}
	else {tem=1;}
	SCCB_C_L();	
	__delay_us(500);	
	SCCB_WR();
	return (tem);  
}

unsigned char SCCBreadByte(void)
{
	unsigned char read,j;
	read=0x00;
	
	SCCB_RD();
	__delay_us(500);
	for(j = 8; j > 0; j--)
	{		     
		__delay_us(500);
		SCCB_C_H();
		__delay_us(500);
		read=read<<1;
		if(SCCB_D_RD() == 1) 
		{
			read=read+1;
		}
		SCCB_C_L();
		__delay_us(500);
	}	
	SCCB_WR();
	return(read);
}

//********************JW[֐**********************************
void wr_Sensor_Reg(unsigned char regID, unsigned char regDat)
{
	startSCCB();
	SCCBwriteByte(0x42);
	__delay_us(100);
  	SCCBwriteByte(regID);
	__delay_us(100);
  	SCCBwriteByte(regDat);
  	stopSCCB();
}

unsigned char rd_Sensor_Reg(unsigned char regID)
{
	unsigned char regDat;
	startSCCB();
	SCCBwriteByte(0x42);
	__delay_us(100);
  	SCCBwriteByte(regID);
	stopSCCB();
	__delay_us(100);
	startSCCB();
	SCCBwriteByte(0x43);
	__delay_us(100);
  	regDat=SCCBreadByte();
  	noAck();
  	stopSCCB();
  	return(regDat);
}

void Sensor_init(void)
{
	unsigned int i;
	wr_Sensor_Reg(0x12, 0x80);
    __delay_ms(10);
	for(i = 0;i < 167; i++)
	{
		wr_Sensor_Reg(OV7670_reg[i][0],OV7670_reg[i][1]);
	}
}

//********************݊֐@**********************************
void INTRPT_Init(void)
{
	//INT荞݃Cl[uCӊ荞݃Cl[uCO[o荞݃Cl[u
	INTCON = 0xD0;//0b11010000
}

//******************荞ݏ@s֐ *************************
static void interrupt intrps(void)
{	unsigned char DA;
	DA = PORTA;
	COL[CNT] |= ((DA & 0x03) + ((DA >> 2) & 0x03));//f[^͉ʃoCgɕۑ
	CNT++;
	INTCON = 0xD0;
}

//********************************C֐**************************************
void main(void)
{
    unsigned short i;
	unsigned char POS1, POS2;
	PIC_Init();
	COM_Init();
	__delay_ms(20);
	for(i = 0; i < 255; i++)
	{	COL[i] = 0;
	}
	PORTB = 0xF0;
	Sensor_init();
	PORTB = 0x00;
	while(1)
	{
		while(PORTBbits.RB1 == 0) {}
		CNT = 0;
		INTCON = 0xD0;//0b11010000 荞݃tOɃNA
		//ŏ̂PC̃f[^ۑ̂҂
		while(CNT < 240) {}
		INTCON = 0x00;
		for(i = 0; i < 240; i++)
		{	COL[i] <<= 4;//ʃoCgփVtgĂ
		}
		//KȎԑ҂
		__delay_ms(500);
		__delay_ms(500);
		while(PORTBbits.RB1 == 0) {}
		CNT = 0;
		INTCON = 0xD0;
		//̂PC̃f[^ۑ̂҂
		while(CNT < 240) {}
		INTCON = 0x00;
		//sg킹ƃfobOɎgpi57600bpsj
		for(i = 0; i < 240; i++)
		{	putc(COL[i]);
		}
		POS1 = POS2 = 0;
		for(i = 0; i < 240 - 1; i++)
		{	if((COL[i] & 0x0F) < (COL[i + 1] & 0x0F)) POS2 = i + 1;
			if(((COL[i] >> 4) & 0x0F) < ((COL[i + 1] >> 4) & 0x0F)) POS1 = i + 1;
		}
		if(POS2 > POS1)
		{	if((POS2 - POS1) > 180) PORTB = 0xF0;
			else if((POS2 - POS1) > 120) PORTB = 0x70;
			else if((POS2 - POS1) > 60) PORTB = 0x30;
			else PORTB = 0x10;
		}
		__delay_ms(500);
		__delay_ms(500);
		PORTB = 0x00;
		for(i = 0; i < 240; i++)
		{	COL[i] = 0;
		}
	}
}
