#include <string.h>
#include "SAMCamera.h"
#include <stdlib.h>
#include "pwm.h"

#define BL_CHAN 2     // Channel number for back light control

void pwm_init()
{
  Pwm *pPWMC = PWM;
  PwmCh_num *pPWMCH;
  Pio *pPIOA = PIOA;

pPIOA->PIO_OER = PIO_PA2;
pPIOA->PIO_CODR = PIO_PA2;

  /*  PA2 as LCD_BL */
  pPIOA->PIO_PDR = PIO_PA2;
  pPIOA->PIO_ABCDSR[0] &= ~PIO_PA2A_PWMH2;
  pPIOA->PIO_ABCDSR[1] &= ~PIO_PA2A_PWMH2;

  pPWMC->PWM_WPCR = 0x50574dfc;

  pPWMCH = &pPWMC->PWM_CH_NUM[BL_CHAN];
  pPWMCH->PWM_CMR = 2;  // MCK / 4

  pPWMCH->PWM_CPRD = 128;
  pPWMCH->PWM_CDTY = 128;

  pPWMC->PWM_ENA = (1 << BL_CHAN);
}

void pwm_set_duty(int newval)
{
  Pwm *pPWMC = PWM;
  PwmCh_num *pPWMCH;

  if (newval > 128) newval = 128;
  if (newval < 0) newval = 0;
  pPWMCH = &pPWMC->PWM_CH_NUM[BL_CHAN];
  pPWMCH->PWM_CDTYUPD = newval;
}

void pwm_command(int argc, char **argv)
{
  int pwm;

    if (argc > 1) {
	pwm = atoi(argv[1]);
	pwm_set_duty(pwm);
	return;
    }
}
